/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class ErgebnisExtendedDAO extends AbstractErgebnisDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: AllNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Ergebnis o<br>
* SQL: <br>
*/
@Override
public java.util.List<Ergebnis> findByAll() {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Ergebnis.findByAll"  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByAll(): Miss");
        }

        cache.put(key, super.findByAll( ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByAll(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Ergebnis>) cache.lookup(key));
    }

    return super.findByAll( );
}
/**
* Name: NameAndErgebnisartAndWahlAutoCompleteNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Ergebnis o WHERE UPPER(o.name) LIKE UPPER(?1) AND o.ergebnisart=?2 and o.wahl = ?3<br>
* SQL: <br>
*/
@Override
public java.util.List<Ergebnis> findByNameAndErgebnisartAndWahlAutoComplete( @javax.annotation.Nonnull String nameAutocompleted,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart,  @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Ergebnis.findByNameAndErgebnisartAndWahlAutoComplete" ,  nameAutocompleted ,  ergebnisart ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByNameAndErgebnisartAndWahlAutoComplete(): Miss");
        }

        cache.put(key, super.findByNameAndErgebnisartAndWahlAutoComplete( nameAutocompleted ,  ergebnisart ,  wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByNameAndErgebnisartAndWahlAutoComplete(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Ergebnis>) cache.lookup(key));
    }

    return super.findByNameAndErgebnisartAndWahlAutoComplete( nameAutocompleted ,  ergebnisart ,  wahl  );
}
/**
* Name: WahlAndErgebnisartNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Ergebnis o WHERE o.wahl = ?1 AND o.ergebnisart=?2<br>
* SQL: <br>
*/
@Override
public java.util.List<Ergebnis> findByWahlAndErgebnisart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Ergebnis.findByWahlAndErgebnisart" ,  wahl ,  ergebnisart  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndErgebnisart(): Miss");
        }

        cache.put(key, super.findByWahlAndErgebnisart( wahl ,  ergebnisart  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndErgebnisart(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Ergebnis>) cache.lookup(key));
    }

    return super.findByWahlAndErgebnisart( wahl ,  ergebnisart  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM Ergebnis o WHERE o.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Ergebnis> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Ergebnis.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Ergebnis>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
